# RateMyUWPlan Developer Guide

RateMyUWPlan is a browser extension that allows users to read and write reviews directly on the MyPlan page for a UW course. Currently, users are able to simply write and read reviews, with future support for logging in, editing and deleting reviews coming soon.


## How to obtain the source code:
To obtain the source code you must clone the repository to your computer, or simply download the source code from gitlab.

## The layout of your directory structure:
The front end is all located in the public folder under the main project folder,
including the html/css/index.js. The back end is located in the app.js
under the main folder. Testing is located in the test folder. Our reports are located
in a reports folder in the main folder. Our databse is also located under the main file.
All other documentation is under the main folder including this guide.

## How to build the software:
Installing Node.js and npm: Make sure that Node.js and npm (which comes bundled with Node.js) are installed on your system.
These can be download from the official Node.js website. To check if they were successfully installed,run node -v and npm -v in your terminal.
Clone or download your project: If your project is version-controlled (e.g., on GitHub), clone the repository to your local machine.
Installing project dependencies: Navigate to the root directory of your project in your terminal. This directory should contain
a package.json file that lists some project dependencies. Run npm install to install all these dependencies.
Start the server: Finally, start the server by running `npm start` or `node app.js` in your terminal. This command will start your server
(main.js, index.js, content.js, background.js etc from our projects root).
Install extension: In chrome go to `chrome://extensions`. Toggle the button in the top right to turn on developer mode,
then click the "Load unpacked" button. Navigate to the `/public` directory and select it. The extension is now loaded. After making any edits to the extension, you can refresh the extension by simply clicking the refresh icon in the manage extension view in chrome.

## How to test the software:
Once all the local project setup has been completed (install prerequisites and dependencies), test cases can be run with `npm test`.

## How to add new tests:
To add new tests, a developer can currently simply add it to the `basictest.js` file in the tests
folder. No specific naming conventions are required. When pushing changes to gitlab,
the CI automatic testing is the only test harness utilized.

## How to build a release of the software:
In order to make a release that is on the Chrome Extensions Webstore, we will need to package
all our code files and the `manifest.json` chrome extension data file into a ZIP. Create or log
into your Chrome Web Store developer account and then upload the ZIP to the dashboard. You can
then submit your ZIP file containing the extension for publishing. Keep in mind this review
process can take up to around 3 days to complete, so plan ahead of time!

We currently do not update the version number or display the stage of development that we are
in (alpha, beta, etc). However, when we package our release and upload it to Chrome Extensions,
will update our `manifest.json` file. The "name" field will be "RateMyUWPlan (Alpha/Beta/etc)".
The "version" we will start with an arbitrary value such as what it is currently, which is 1.0.
When we make major updates that we want to release to the public on the Chrome Extensions store,
we will increment this value.

For sanity checking, you can check your uploaded ZIP file containing your Chrome Extension for
if there are any issues in the uploading process or if there is something wrong with the code.
Once the Chrome Extension is approved, you can do another check of the extension before you
publish it for the public!
