let pars = document.querySelectorAll("p");

console.log("test");
console.log(pars);

for (let i = 0; i < pars.length; i++) {
  console.log(pars[i].textContent);
  pars[i].textContent = "hello myplan!";
}

const dashboardDiv = document.createElement("div");
dashboardDiv.id = "dashboardDivID";
const reviewsDiv = document.createElement("div");
reviewsDiv.id = "reviewsDivID";
var isDashboardVisible = 0
var requestDone = 0;
var currClass = null;

/**
   * Asynchronous function that checks whether a fetch call was successful.
   * @param {object} response - JSON object representing the response
   * @returns {object} - The same response, if the status check was successful.
   */
  async function statusCheck(response) {
    if (!response.ok) {
      throw new Error(await response.text());
    }
    return response;
  }



// Create a <style> element
const styleElement = document.createElement('style');

// Set the content of the <style> element to the CSS rules
styleElement.textContent = `
  .review-bar-container {
    display: flex;
    justify-content: space-between; /* Create space between bars */
    align-items: center;
    margin-bottom: 10px;
  }

  .review-bar {
    display: flex;
    align-items: center;
  }

  .review-bar-left {
    justify-content: flex-start; /* Align bars and labels on the left */
  }

  .review-bar-right {
    justify-content: flex-end; /* Align bars and labels on the right */
  }

  .review-bar progress {
    height: 12px;
    width: 150px; /* Adjust the width to control the overall size of the bars */
    margin-left: 10px;
    border-radius: 0;
  }

  .review-bar b {
    display: inline-block;
    width: 110px;
    text-align: right;
    margin-right: 10px;
  }

  .review-bar-progress {
    appearance: none;
    width: 100%;
    height: 100%;
    border: none;
    background-color: #FEDD6C;
  }

  .review-bar-progress::-webkit-progress-bar {
    background-color: #ddd;
    border-radius: 0;
  }

  .review-bar-progress::-webkit-progress-value {
    background-color: #FEDD6C;
    border-radius: 0;
  }
`;

// Append the <style> element to the document's <head> section
document.head.appendChild(styleElement);




var createButton = setInterval(() => {
    var button = document.createElement("button");
    button.id = 'SeeReviewsButton';
    button.style.background = '#FEDD6C'
    button.style.border = '#FEDD6C'
    button.style.display = 'inline-block'
    button.style.padding = '0.375rem 2.5rem';
    button.textContent = "See Reviews";
    button.style.fontWeight = '600';
    button.style.borderRadius = '.25rem';
    button.classList.add("chrome-extension-button");
    button.onclick = function () {
         const currentDiv = document.getElementsByClassName("row mt-3");
         currentDiv[0].appendChild(dashboardDiv);
         if (isDashboardVisible == 0) {
             currentDiv[0].appendChild(dashboardDiv);
             currentDiv[0].appendChild(reviewsDiv);
             isDashboardVisible = 1;
             button.textContent = "Hide Reviews";
             //get request
             var fullHeader = document.getElementsByClassName("page-heading")[0].firstElementChild.innerHTML.split(" ")
             var classCode = "";
             for (let i = 0; i < fullHeader.length; i++) {
               if (!isNaN(fullHeader[i])) {
                classCode += " " + fullHeader[i];
                break;
               }
                classCode += fullHeader[i];
              }
             if (requestDone == 0 || currClass != classCode) {
                 currClass = classCode;
                 console.log("getting reviews");
                 var loggedInUser;
                 chrome.runtime.sendMessage({type: "getCurrUser"}, (response1) => {
                     loggedInUser = response1;
                 });
                 chrome.runtime.sendMessage({type: "getdata", class: classCode}, (response) => {
                    console.log(response);
//                    console.log(response[0].review_text);
//                    response_length = response.length;
                    while (reviewsDiv.firstChild) {
                        reviewsDiv.firstChild.remove()
                    }
                    reviewsDiv.appendChild(document.createElement('br'));
                    if (response.length == 0) {
                        reviewsDiv.appendChild(document.createTextNode("No reviews available for this class"));
                    } else {
                        var reviewText = document.createElement('b');
                        reviewText.innerHTML = "Reviews: ";
                        reviewsDiv.appendChild(reviewText);
                        dashboardDiv.appendChild(document.createElement('br'));
                        reviewsDiv.appendChild(document.createElement('br'));
                        const loggedInReviews = new Set();

                        for (let i = 0; i < response.length; i++) {
                            if (response[i].user == loggedInUser) {
                                loggedInReviews.add(response[i].review_id);
                            }
                        }

                        for (let i = 0; i < response.length; i++) {
                            const curr_review = document.createTextNode(response[i].review_text);
                            currReviewer = document.createTextNode("Review by: " + response[i].displayname);
                            currReviewDiv = document.createElement("div");
                            currReviewDiv.id = response[i].review_id;
                            currReviewDiv.appendChild(currReviewer);
                            currReviewDiv.appendChild(document.createElement('br'));
                            currReviewDiv.appendChild(curr_review);
                            var deleteButton = document.createElement("button");
                            deleteButton.id = response[i].review_id;
                            deleteButton.textContent = "Delete";
                            deleteButton.classList.add("chrome-extension-button");
                            deleteButton.onclick = function () {
                                alert("Review successfully deleted.");
                                location.reload();
                                chrome.runtime.sendMessage({type: "deleteReview", id: deleteButton.id}, (response) => {});
                            }
                            if (loggedInReviews.has(response[i].review_id)) {
                                currReviewDiv.appendChild(document.createElement('br'));
                                currReviewDiv.appendChild(deleteButton);
                            }

                            currReviewDiv.appendChild(document.createElement('br'));
                            currReviewDiv.appendChild(document.createElement('br'));
                            reviewsDiv.appendChild(currReviewDiv);
                        }
                        var getRatingsRequest = classCode + "/ratings";
                        chrome.runtime.sendMessage({ type: "getdata", class: getRatingsRequest }, (response) => {
                            console.log(response);
                            const avg_total = response[0].avg_overall.toFixed(1);
                            const avg_fun = response[0].avg_fun.toFixed(1);
                            const avg_time = response[0].avg_time.toFixed(1);
                            const avg_diff = response[0].avg_difficulty.toFixed(1);


                            // Create a container div for left-side bars and labels
                            const leftContainer = document.createElement("div");
                            leftContainer.style.float = "left";
                            leftContainer.style.marginRight = "150px";

                            // Create a container div for right-side bars and labels
                            const rightContainer = document.createElement("div");
                            rightContainer.style.float = "left";


                            const avgTotalLabel = document.createTextNode("Average Total Rating:        ");
                            const avgTotalBar = document.createElement("div");
                            avgTotalBar.classList.add("review-bar");

                            const avgTotalProgressBar = document.createElement("progress");
                            avgTotalProgressBar.max = 5;
                            avgTotalProgressBar.value = avg_total;
                            avgTotalProgressBar.classList.add("review-bar-progress");

                            avgTotalBar.appendChild(avgTotalLabel);
                            avgTotalBar.appendChild(avgTotalProgressBar);


                            const avgFunLabel = document.createTextNode("Average Fun Rating:        ");
                            const avgFunBar = document.createElement("div");
                            avgFunBar.classList.add("review-bar");

                            const avgFunProgressBar = document.createElement("progress");
                            avgFunProgressBar.max = 5;
                            avgFunProgressBar.value = avg_fun;
                            avgFunProgressBar.classList.add("review-bar-progress");

                            avgFunBar.appendChild(avgFunLabel);
                            avgFunBar.appendChild(avgFunProgressBar);



                            // Append average total and average fun rating bars to the left container
                            leftContainer.appendChild(avgTotalBar);
                            leftContainer.appendChild(avgFunBar);

                            // Append left container to the dashboardDiv
                            dashboardDiv.appendChild(leftContainer);


                            const avgTimeLabel = document.createTextNode("Average Time Rating:      ");
                            const avgTimeBar = document.createElement("div");
                            avgTimeBar.classList.add("review-bar");

                            const avgTimeProgressBar = document.createElement("progress");
                            avgTimeProgressBar.max = 5;
                            avgTimeProgressBar.value = avg_time;
                            avgTimeProgressBar.classList.add("review-bar-progress");

                            avgTimeBar.appendChild(avgTimeLabel);
                            avgTimeBar.appendChild(avgTimeProgressBar);


                            const avgDiffLabel = document.createTextNode("Average Difficulty Rating:        ");
                            const avgDiffBar = document.createElement("div");
                            avgDiffBar.classList.add("review-bar");

                            const avgDiffProgressBar = document.createElement("progress");
                            avgDiffProgressBar.max = 5;
                            avgDiffProgressBar.value = avg_diff;
                            avgDiffProgressBar.classList.add("review-bar-progress");

                            avgDiffBar.appendChild(avgDiffLabel);
                            avgDiffBar.appendChild(avgDiffProgressBar);



                            // Append average time and average difficulty rating bars to the right container
                            rightContainer.appendChild(avgTimeBar);
                            rightContainer.appendChild(avgDiffBar);

                            // Append right container to the dashboardDiv
                            dashboardDiv.appendChild(rightContainer);
                        });
                    }
                    requestDone = 1;
                 });
                 // give intuitive error message on failed fetchs
                 if (requestDone == 0) {
                    while (reviewsDiv.firstChild) {
                        reviewsDiv.firstChild.remove()
                    }
                    reviewsDiv.appendChild(document.createElement('br'));
                    reviewsDiv.appendChild(document.createTextNode("Server is down, currently cannot retrieve reviews for this class"));
                 }
             }

         } else {
             currentDiv[0].removeChild(dashboardDiv);
             currentDiv[0].removeChild(reviewsDiv);
             isDashboardVisible = 0;
             button.textContent = "See Reviews";
         }
    }
    const headingElement = document.getElementsByClassName("page-heading")
    const currentDiv = document.getElementsByClassName("row mt-3");
    if (headingElement[0] != null && currentDiv != null &&
        headingElement[0].firstChild.innerHTML != "Find Courses") {
        const buttonDiv = document.createElement('div');
        buttonDiv.appendChild(button);
        currentDiv[0].appendChild(buttonDiv);
        clearInterval(createButton)
    }
}, 50);


// logs rating into console for now. Change later
const difficultyInput = document.getElementById("difficulty");
const timeCommitmentInput = document.getElementById("time_commitment");
const funInput = document.getElementById("fun");

difficultyInput.addEventListener("input", (event) => {
  const difficultyRating = event.target.value;
  console.log(`Difficulty: ${difficultyRating}`);
});

timeCommitmentInput.addEventListener("input", (event) => {
  const timeCommitmentRating = event.target.value;
  console.log(`Time commitment: ${timeCommitmentRating}`);
});

funInput.addEventListener("input", (event) => {
  const funRating = event.target.value;
  console.log(`Fun: ${funRating}`);
});


