const LOCAL_DEBUG = false;
const url = (LOCAL_DEBUG) ? "http://localhost:2903" : "http://attu7.cs.washington.edu:2903";

// Login using username (netid)

// currently not working
window.addEventListener("load", init);

let isLoggedIn = false; // boolean variable to track login status

function init() {
    const loginForm = document.getElementById("login-form");
    const registerForm = document.getElementById("register-form"); // Get the register form


    chrome.runtime.sendMessage({type: "getCurrUser"}, (response) => {
        if (response != null) {
            isLoggedIn = true;
            window.location.href = "index.html"; // Redirect to index.html

        }
    });

    loginForm.addEventListener("submit", async (event) => {
        event.preventDefault();
        let username = document.getElementById("username").value;

        try {
            const response = await fetch(url + '/users/login', {
                method: "POST",
                headers: {
                    "Content-Type": "application/json"
                },
                body: JSON.stringify({ username })
            });

            if (response.ok) {
                // Login success
                isLoggedIn = true;
                window.location.href = "index.html"; // Redirect to index.html

                console.log(username);
                chrome.runtime.sendMessage({type: "login", user: username}, (response) => {});

                console.log("Login success");
            } else {
                // Login failed
                isLoggedIn = false;
                console.error("Login failed");
                const loginStatus = document.getElementById("loginStatus");
                loginStatus.textContent = "Login Failed";
            }
        } catch (error) {
            isLoggedIn = false;
            console.error("An error occurred during login:", error);
        }
    });
    registerForm.addEventListener("submit", (event) => {
        event.preventDefault();
        let newUsername = document.getElementById("new-username").value;
        let displayName = document.getElementById("new-displayname").value;
        let registerData = new FormData();
        registerData.append("username", newUsername);
        registerData.append("display-name", displayName);

        fetch(url + "/users/create", {method: 'POST', body: registerData})
            .then(statusCheck)
            .then(resp => resp.text())
            .then((resp) => {
                const registerStatus = document.getElementById("registerStatus");
                registerStatus.textContent = "Registration successful!";
            })
            .catch((err) => {
                const registerStatus = document.getElementById("registerStatus");
                registerStatus.textContent = "Registration failed!";
                console.error(err);
            });
    });

}

/**
 * Asynchronous function that checks whether a fetch call was successful.
 * @param {object} response - JSON object representing the response
 * @returns {object} - The same response, if the status check was successful.
 */
async function statusCheck(response) {
    if (!response.ok) {
        throw new Error(await response.text());
    }
    return response;
}