# Team Report

## Goals from previous week:
- Implement automated testing and CI
- Create tables in MySQL database, create simple necessary endpoints.
- Create skeleton form in index.html/index.js
- Figure out DOM manipulation for myplan (content.js is currently being run before myplan fully populates the content)

## Progress Report
- GitLab CI automated testing pipeline is setup
- Simple tables create, switched to SQLite for simplicity for now
- "Show Reviews" button now showing up on MyPlan
- Started skeleton form form popup menu

## Goals for next week
- Create basic endpoints for backend database access
- Fix weird bugs/quirks involving the "Show Reviews" button not showing up in edge cases
- Finish form in popup menu

# Contributions of individual team members

## Junha Lee
### Goals from previous week:
- Figure out testing/CI infrastructure, probably with npm or Gitlab, need to do research first.

### Progress Report
- Got testing/CI infrastructure finished using Gitlab pipeline, utilizing my laptop as the only runner right now

### Goals for next week
- Finish simple endpoints, most important are GET ratings for class, GET reviews for class, POST review for class

## Ali Al-Shimari
### Goals from previous week:
- Continue setting up basic setup for front end and backend framework

### Progress Report
- Working on framework for front end pop up menu for extension.

### Goals for next week
- Continue working on basic setup for front end and backend framework


## Bella Cooper
### Goals from previous week:
- Continue setting up front-end and back-end frameworks

### Progress Report
- Assisted team with documenting testing framework decisions
- Created See Reviews button on Course page

### Goals for next week
- Fix bugs with See Reviews button and test it in several cases
- Work on styling for See Reviews Button 

## Kenneth Lee
### Goals from previous week:
- As Junha begins to set up backend endpoints, will start creating queries that can be executed in MySQL database
- Currently setting up a local MySQL server for development is tedious process and you would need to manually input test database, potentially host database in online cloud service provider that all backend engineers can connect to

### Progress Report
- Evaluated MySQL vs sqlite3 for application and determined sqlite is better for local development as database is hosted in Gitlab project and can be easily distributed to all backend engineers
- Set up sqlite3 and added code for creating reviews database and also query from it
- Fixed issue in content.js where see reviews button is displayed on non-course pages

### Goals for next week
- Create sqlite3 queries for endpoints for posting reviews, retrieving reviews, and deleting reviews.

## Clarence Muchina
### Goals from previous week:
- Assist with front-end assignment with Ali.
- Produce something visible on screen.

### Progress Report
- Made major progress on front-end assignment, produced a review box, and Introductory home page.

### Goals for next week
- Make further progress on home page, possibly have sliders completed for components of pop up

## Brenda Ruvalcaba
### Goals from previous week:
- Get access to a data base system, so that we can start implementing SQL queries, and start building the data base.
- Start building the implementation design of the front-end, or the back-end.

### Progress Report
- Started working on the front-end design.
- Finished a basic prototype of the button for our extension.

### Goals for next week
- Have full functionality for the extension button.
- Have a front end design ready (pop-up window).


