# Team Report

## Goals from previous week:
- Create basic endpoints for backend database access
- Fix weird bugs/quirks involving the "Show Reviews" button not showing up in edge cases
- Finish form in popup menu

## Progress Report
- Basic endpoints complete
- Show reviews button shows up properly on class pages
- Form in popup menu complete
- Form functionality finished, reviews can be properly submitted through extension

## Goals for next week
- Better styling/formatting for show reviews on the page
- Add endpoints for user interactions (login, edit review, delete review)
- Implement more use cases in frontend.

# Contributions of individual team members

## Junha Lee
### Goals from previous week:
- Finish simple endpoints, most important are GET ratings for class, GET reviews for class, POST review for class

### Progress Report
- 3 simple endpoints completed and documented
- Added extra tests for our GET requests

### Goals for next week
- Add testing for POST request
- Add more endpoints

## Ali Al-Shimari
### Goals from previous week:
- Continue working on basic setup for front end and backend framework

### Progress Report
- Pop up window works well including endpoints

### Goals for next week
- Clean up front end, and finish pop up front end components

## Bella Cooper
### Goals from previous week:
- Fix bugs with See Reviews button and test it in several cases
- Work on styling for See Reviews Button

### Progress Report
- Got see reviews button connected to backend
- Populated reviews and average ratings with data when button is clicked

### Goals for next week
- Work on UI and styling for reviews shown
- Continue testing see reviews button

## Kenneth Lee
### Goals from previous week:
- Create sqlite3 queries for endpoints for posting reviews, retrieving reviews, and deleting reviews.

### Progress Report
- Created sqlite3 queries for getting class reviews, average ratings, and posting reviews for a class

### Goals for next week
- Create additional endpoints beyond first 3 endpoints as needed
- Add/improve on documentation for backend

## Clarence Muchina
### Goals from previous week:
- Make further progress on home page, possibly have sliders completed for components of pop up

### Progress Report
- Was able to implement sliders and other components for pop up extension.

### Goals for next week
- Allow users to edit and view their reviews as well as login through our extension.

## Brenda Ruvalcaba
### Goals from previous week:
- Have full functionality for the extension button.
- Have a front end design ready (pop-up window).

### Progress Report
- Worked on the front-end interaction with the back-end database.
- Explained the process timeline of RateMyUwPlan on the team reflection.

### Goals for next week
- Polish the front-end to have a better design for the user.
- Test the front-end and see if there are any data bridges that might affect the security of the user.


