# Team Report

## Goals from previous week:
- Better styling/formatting for show reviews on the page
- Add endpoints for user interactions (login, edit review, delete review)
- Implement more use cases in frontend.

## Progress Report
- More involved endpoints added (login, edit, delete).
- Show Reviews button position and styling tweaked
- Show reviews script edited to use endpoint to compute average rather than manually computing it
- Added is-anonymous attribute to reviews, edited submission form to reflect this change

## Goals for next week
- Finish login/edit/deletion in frontend
- More thorough styling
- Add more tests/documentation

# Contributions of individual team members

## Junha Lee
### Goals from previous week:
- Add testing for POST request
- Add more endpoints

### Progress Report
- Endpoints added for login, edit, delete
- Submit endpoint modified to be more strict (doesn't allow duplicate reviews from same user for a class)
- Edited endpoints to support the new is-anonymous attribute

### Goals for next week
- More thorough endpoint testing for POST requests
- Help with frontend features as most major backend endpoints are complete
- Tweak/add backend endpoints as needed.

## Ali Al-Shimari
### Goals from previous week:
- Clean up front end, and finish pop up front end components

### Progress Report
- Fixed back end bug with subbmitting review

### Goals for next week
- Implement front end for log i

## Bella Cooper
### Goals from previous week:
- Work on UI and styling for reviews shown
- Continue testing see reviews button

### Progress Report
- changed manual calculations of averages to be calling endpoints
- styled see reviews button to better match UI of the page
- changed location of button to match original wireframes

### Goals for next week
- Continue to work on styling and on the UI
- Continue testing see reviews button

## Kenneth Lee
### Goals from previous week:
- Create additional endpoints beyond first 3 endpoints as needed
- Add/improve on documentation

### Progress Report
- Had a bad fever for majority of week but was able to make some progress:
- Added to documentation
- Fixed bug with anonymous checkbox html
- Fixed handling checkbox input issues

### Goals for next week
- Backend work mostly done so transitioning to helping with front-end and full stack design
  such as improving styling and tweaking behavior slightly

## Clarence Muchina
### Goals from previous week:
- Make further progress on home page, possibly have sliders completed for components of pop up

### Progress Report
- Was able to implement sliders and other components for pop up extension.

### Goals for next week
- Allow users to edit and view their reviews as well as login through our extension.

## Brenda Ruvalcaba
### Goals from previous week:
- Polish the front-end to have a better design for the user.
- Test the front-end and see if there are any data bridges that might affect the security of the user.

### Progress Report
- Added reviews' bars for a better display of the front-end page.
- Worked on accessing the data base to connect the data to the reviews' bars

### Goals for next week
- Polish the front-end display bars so that they comply with the desired design.


