# RateMyUWPlan User Guide

RateMyUWPlan is a browser extension that allows users to read and write reviews directly on the MyPlan page for a UW course. Currently, users are able to simply write and read reviews, with future support for logging in, editing and deleting reviews coming soon.

## Install and Run Guide

UPDATE: Chrome extension has been reviewed and accepted, you can find the link [here](https://chrome.google.com/webstore/detail/ratemyuwplan/ijgopmdkjpakkgpfbinmkgoblkdpigfa?hl=en&authuser=0).

### Steps

- Ensure that you have chrome installed (may work on other chromium-based browsers, not yet tested)
- Navigate to [https://chrome.google.com/webstore/detail/ratemyuwplan/ijgopmdkjpakkgpfbinmkgoblkdpigfa?hl=en&authuser=0](https://chrome.google.com/webstore/detail/ratemyuwplan/ijgopmdkjpakkgpfbinmkgoblkdpigfa?hl=en&authuser=0)
- Click the "Add to chrome" button

NOTE: If features of the browser extension appear to not be working please message Junha Lee (realjlee) on slack or send an email to
realjlee@uw.edu in case the backend server is down.

## Usage Guide

In order to find the reviews for a UW class, go to the MyPlan page (`myplan.uw.edu`) for that class. A newly added "See Reviews" button should appear above the "Course Sections" part of the webpage. Clicking this button will expand a list of reviews for that class, as well as average ratings for the class.

In order to add a review for a UW class you must first be logged in. Click the extension icon in the top right of chrome in order to open the login form. Currently all we require for a valid login is a username. If you would like to create a new account to login with there is an option to do so underneath the login form.

Once logged in, you then need to navigate to the MyPlan class page that you want to leave a review for. If you are on an invalid page the extension popup will contain a message saying that you are not currently on a valid UW class page. If you are on a valid page it should tell you what class you are leaving a review for. Once this message shows up, you can fill out the review form and submit your review! NOTE: If you have already left a review for the class, the form will prompt you for if you want to overwrite your old review. If you click ok, your old review will be edited to include your new review data.

While logged in, you can also delete any reviews you've left for a class. To do so, go to the MyPlan class page containing the review you want to delete. Open the list of reviews for the class, and there should now be a "delete" button under any reviews that you have left for the class. Clicking this button will delete your review and refresh the page.

In order to logout, simply open the extension popout in the top right. Click the "logout" button in the bottom left of the popup in order to log out of the extension.

## Work in Progress features

- Certain control flows for use cases not implemented that would improve user comfort.
- Limit the number of reviews that can appear at once unless prompted by the user otherwise (i.e. don't spam the page with 100 reviews if 100 reviews have been left for the class, start with first 10, then user asks for more, etc.)

## Reporting a bug

When reporting a bug, leaving an issue on our gitlab page is sufficient, for good guidelines on writing bug reports, please refer to [this guide](https://bugzilla.mozilla.org/page.cgi?id=bug-writing.html).

## Known bugs

- After navigating to a class page, if user clicks "back" then "forward" in their browser, the class page will no longer have the "Show Reviews" button. Reloading fixes this issue.